@echo off
rem *** Author: T. Wittrock, RZ Uni Kiel ***

verify other 2>nul
setlocal enableextensions
if errorlevel 1 goto NoExtensions

%~d0
cd "%~p0"

:EvalParam
if "%1"=="" goto NoMoreParam
if /i "%1"=="/proxy" (
  set http_proxy=%2
  shift /1
)
shift /1
goto EvalParam
:NoMoreParam

if "%TEMP%"=="" goto NoTemp
pushd "%TEMP%"
if errorlevel 1 goto NoTempDir
popd

set CSCRIPT_PATH=%SystemRoot%\system32\cscript.exe
if not exist %CSCRIPT_PATH% goto NoCScript
if not exist ..\bin\wget.exe goto NoWGet

rem *** Copy Microsoft registry console tool ***
echo Copying Microsoft registry console tool...
if exist ..\client\bin\reg.exe goto SkipRegExe
if not exist ..\client\bin\nul md ..\client\bin
if exist %SystemRoot%\system32\reg.exe (copy %SystemRoot%\system32\reg.exe ..\client\bin) else goto NoRegExe
:SkipRegExe

rem *** Download statics ***
echo Downloading statics...
for %%i in (msi wsus) do (
  ..\bin\wget.exe -N -i ..\static\StaticDownloadLinks-%%i.txt -P ..\client\%%i
  if errorlevel 1 goto DownloadError
)
if not exist ..\client\bin\ifmember.exe (
  if not exist ..\bin\msiextract.exe goto NoMSIExtract
  ..\bin\wget.exe -N -i ..\static\StaticDownloadLink-ifmember.txt -P "%TEMP%\ifmember"
  if errorlevel 1 goto DownloadError
  "%TEMP%\ifmember\IfMember_Setup.exe" /T:"%TEMP%\ifmember" /C
  copy ..\bin\msiextract.exe "%TEMP%\ifmember" 
  pushd "%TEMP%\ifmember"
  msiextract.exe ifmember.Msi
  popd
  move "%TEMP%\ifmember\ifmember.exe" ..\client\bin > nul
  rd /S /Q "%TEMP%\ifmember"
)
for %%i in (w2k wxp w2k3 win) do (
  for %%j in (deu enu nld esn fra ptg ptb) do (
    ..\bin\wget.exe -N -i ..\static\StaticDownloadLinks-%%i-%%j.txt -P ..\src\%%i\%%j
    if errorlevel 1 goto DownloadError
  )
)

rem *** Download installation files for IE6 ***
for %%j in (deu enu nld esn fra ptg ptb) do (
  rem *** Only required for w2k ***
  echo Downloading installation files for IE6 %%j...
  ..\bin\wget.exe -nv -N -i ..\static\StaticDownloadLinks-ie6-%%j.txt -P ..\client\win\%%j\ie6setup
  if errorlevel 1 goto DownloadError
  call FixIE6SetupDir.cmd %%j
  if errorlevel 1 goto DownloadError
)

rem *** Extract updates ***
echo Extracting updates...
%CSCRIPT_PATH% //Nologo //E:vbs ExtractUpdatesFromWSUS.vbs

rem *** Copy statics ***
echo Copying statics...
xcopy ..\src\*.* ..\client\*.* /S /Y

REM *** Remind build date ***
echo Reminding build date...
date /T > ..\client\builddate.txt

rem *** Create ISO images ***
for %%i in (w2k wxp w2k3) do (
  for %%j in (deu enu nld esn fra ptg ptb) do (
    call CreateISOImage.cmd %%i %%j
  )
)
call CreateISOImage.cmd all

rem *** Clean client tree ***
echo Cleaning client tree...
for %%i in (w2k wxp w2k3 win) do rd /S /Q ..\client\%%i 

goto EoF

:NoExtensions
echo.
echo ERROR: No command extensions available.
echo.
goto EoF

:NoTemp
echo.
echo ERROR: Environment variable TEMP not set.
echo.
goto Error

:NoTempDir
echo.
echo ERROR: Directory "%TEMP%" not found.
echo.
goto Error

:NoCScript
echo.
echo ERROR: VBScript interpreter %CSCRIPT_PATH% not found.
echo.
goto EoF

:NoWGet
echo.
echo ERROR: Utility ..\bin\wget.exe not found.
echo.
goto EoF

:NoMSIExtract
echo.
echo ERROR: Utility ..\bin\msiextract.exe not found.
echo.
goto EoF

:NoRegExe
echo.
echo ERROR: Utility %SystemRoot%\system32\reg.exe not found.
echo If you run Windows 2000, try to manually extract this file out of
echo the \SUPPORT\TOOLS\SUPPORT.CAB file on your installation CD and
echo copy it to the directory ..\client\bin.
echo.
goto EoF

:DownloadError
echo.
echo ERROR: Download failure.
echo.
goto EoF

:EoF
endlocal
